import { Injectable } from '@angular/core';

let nodeId: number | undefined;
function getOneOf(arr: string[]) {
    return arr[Math.floor(Math.random() * arr.length)];
}

@Injectable()
export class DataService {
    getData() {
        let tree = this.getNodes(nodeId, 5);
        tree.forEach(node => node.children.push(this.createNode(true)));
        return tree;
    }
    createNode(dummy?: boolean): any {
        let first = 'Al,Bob,Cal,Dan,Ed,Fred,Greg,Hal,Ian,Jack,Karl,Lou,Moe,Nate,Oleg,Paul,Quincy,Rod,Sue,Uwe,Vic,Walt,Xiu,Yuri,Zack'.split(','),
            last = 'Adams,Baum,Cole,Dell,Evans,Fell,Green,Hill,Isman,Jones,Krup,Lee,Monk,Nye,Opus,Pitt,Quaid,Riems,Stark,Trell,Unger,Voss,Wang,Xie,Zalm'.split(','),
            name = dummy ? '' : getOneOf(first) + ' ' + getOneOf(last),
            children:any = [];
        // if (!dummy) {
        //     children.push(this.createNode(true));
        // }
        if (nodeId == null) nodeId = 0;
        return { id: nodeId++, name: name, children: children, $_dummyNode: dummy };
    }

    getNodes(rowId: number, count?: number) {
        // you can used the rowId or any such data from the current row
        // to get corresponding nodes for the row
        if (!count) {
            count = this.getRandomNodeCount();
        }

        let nodes = [];
        for (let i = 0; i < count; i++) {
            nodes.push(this.createNode());
        }

        return nodes;
    }

    getRandomNodeCount() {
        return Math.floor(Math.random() * 4); // Generates a random number between 0 and 4
    }
}